###################################################
### chunk number 1: preliminaries
###################################################
#line 6 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
options(prompt = "R> ")


###################################################
### chunk number 2: 
###################################################
#line 148 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
library("clues")


###################################################
### chunk number 3: 
###################################################
#line 333 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
WDBC <- read.table("WDBC.dat", sep = ",", header = FALSE)
colnames(WDBC) <- c("ID", "caco", paste("dim", 1:30, sep=""))

# the true cluster membership
WDBC.mem <- rep(NA, length(WDBC$caco))
WDBC.mem[WDBC$caco == "M"] <- 1
WDBC.mem[WDBC$caco == "B"] <- 2

head(WDBC[, 1:6])


###################################################
### chunk number 4: 
###################################################
#line 347 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
sdVec <- apply(WDBC[, -c(1:2)], 2, sd)
round(quantile(sdVec), 3)


###################################################
### chunk number 5: 
###################################################
#line 356 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
dat <- as.matrix(WDBC[ , -c(1:2)])
dat.s <- apply(dat, 2, scale, center = TRUE, scale = TRUE)
colnames(dat.s)<-colnames(WDBC)[-c(1:2)]

res.sil <- clues(dat.s, strengthMethod = "sil", disMethod = "Euclidean")


###################################################
### chunk number 6: 
###################################################
#line 366 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
summary(res.sil)


###################################################
### chunk number 7: fig1 eval=FALSE
###################################################
## #line 385 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
## plotClusters(dat.s, res.sil$mem, plot.dim = c(1, 4, 9, 10),
##   cex.points = 0.01)


###################################################
### chunk number 8: fig1a
###################################################
#line 392 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
#line 385 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw#from line#392#"
plotClusters(dat.s, res.sil$mem, plot.dim = c(1, 4, 9, 10),
  cex.points = 0.01)
#line 393 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"


###################################################
### chunk number 9: fig2 eval=FALSE
###################################################
## #line 403 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
## plotAvgCurves(dat.s, res.sil$mem, cex.axis=0.3, ylim=c(-1, 1.5),
##   las=1, cex.axis=1)


###################################################
### chunk number 10: fig2a
###################################################
#line 410 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
#line 403 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw#from line#410#"
plotAvgCurves(dat.s, res.sil$mem, cex.axis=0.3, ylim=c(-1, 1.5),
  las=1, cex.axis=1)
#line 411 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"


###################################################
### chunk number 11: 
###################################################
#line 419 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
get_Silhouette(dat.s,res.sil$mem)$avg.s


###################################################
### chunk number 12: 
###################################################
#line 430 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
accuracy <- sum(WDBC.mem == res.sil$mem) / length(WDBC.mem)
round(accuracy, 2)

library("cluster")
set.seed(12345)
res.km <- kmeans(dat.s, 2, algorithm = "MacQueen")
res.pam <- pam(dat.s, 2)

accuracy.km <- sum(WDBC.mem == res.km$cluster) / length(WDBC.mem)
round(accuracy.km, 2)

accuracy.pam <- sum(WDBC.mem == res.pam$clustering) / length(WDBC.mem)
round(accuracy.pam, 2)


###################################################
### chunk number 13: 
###################################################
#line 486 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
res.CH <- clues(dat.s, strengthMethod = "CH", quiet = TRUE)
memMat <- cbind(WDBC.mem, res.sil$mem, res.CH$mem, res.km$cluster, res.pam$clustering)
colnames(memMat) <- c("true", "clues.sil", "clues.CH", "km", "pam")
res<-compClust(dat.s, memMat)
print(sapply(res, round, digits = 2))


###################################################
### chunk number 14: fig3 eval=FALSE
###################################################
## #line 532 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
## pairs(jj, pch = 21, bg = c("red", "yellow", "purple")[unclass(iris$Species)])


###################################################
### chunk number 15: fig4 eval=FALSE
###################################################
## #line 536 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
## pairs(shrinkres_jitter[, 1:4], pch = 21, bg = c("red", "purple", "yellow")[unclass(shrinkres_group)])


###################################################
### chunk number 16: 
###################################################
#line 540 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
data("iris")
jj <- as.matrix(iris[,1:4])
#line 532 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw#from line#542#"
pairs(jj, pch = 21, bg = c("red", "yellow", "purple")[unclass(iris$Species)])
#line 543 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
shrinkres <- shrinking(jj, K = 60, disMethod = "Euclidean", itmax = 3)
dimnames(shrinkres) <- dimnames(jj)
convergepnts <- shrinkres[c(1, 51, 52, 54), ]
row1 <- t(matrix(jitter(rep(convergepnts[1, ], 50)), nrow = 4))
row2 <- t(matrix(jitter(rep(convergepnts[2, ], 51)), nrow = 4))
row3 <- t(matrix(jitter(rep(convergepnts[3, ], 18)), nrow = 4))
row4 <- t(matrix(jitter(rep(convergepnts[4, ], 31)), nrow = 4))
shrinkres_jitter <- rbind(row1, row2, row3, row4)
shrinkres_group <- as.factor(rep(1:3, c(50, 51, 49)))
colnames(shrinkres_jitter) <- colnames(shrinkres) 
#line 536 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw#from line#553#"
pairs(shrinkres_jitter[, 1:4], pch = 21, bg = c("red", "purple", "yellow")[unclass(shrinkres_group)])
#line 554 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"


###################################################
### chunk number 17: fig3a
###################################################
#line 559 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
#line 532 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw#from line#559#"
pairs(jj, pch = 21, bg = c("red", "yellow", "purple")[unclass(iris$Species)])
#line 560 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"


###################################################
### chunk number 18: fig4a
###################################################
#line 568 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"
#line 536 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw#from line#568#"
pairs(shrinkres_jitter[, 1:4], pch = 21, bg = c("red", "purple", "yellow")[unclass(shrinkres_group)])
#line 569 "d:/Rcompile/CRANpkg/local/2.12/clues/inst/doc/clues.Rnw"


